RESET:	
  ;     (        wdr  Atmega16 (  4.11 build 406 SP2  )).
	.if	BuildForSimulator == 0 
	in	Temp, WDTCR
	sbr	Temp, (1<<WDE)|(1<<WDP2)|(1<<WDP1)|(1<<WDP0)
	out	WDTCR, Temp	;    - 
	wdr			; -   2 .
	.endif

  ;  .
;	in	Temp, MCUCR
;	sbr	Temp, (1<<SE)|(1<<SM0); ADC Noise Reduction.
;	out	MCUCR, Temp
	
  ; .
	ldi	Temp, HIGH(RAMEND)
	out	SPH, Temp 
	ldi	Temp, LOW(RAMEND)
	out	SPL, Temp
	
  ;  /.
	ldi	Temp, 0b11111100;   -  ,
	out	PORTA, Temp	; -   .
	ldi	Temp, 0b00000011;   -  ,
	out	DDRA, Temp	; - .
	ser	Temp		; , , D - .
	out	PORTC, Temp	;  .
	out	PORTD, Temp
	ldi 	Temp, 0b11111011;     
	out	PORTB, Temp	; 3- -     .
	
  ; JTAG  .
	in	Temp, MCUCSR
	sbr	Temp, (1<<JTD)	
	out	MCUCSR, Temp	;To avoid static current at the TDO pin.
 	out	MCUCSR, Temp	;To change JTD bit its value must be modified twice within 4 cycles.
	sbi	ACSR, ACD	;   (  ).
		
  ;  .
	in	Temp, GICR	;   INT2   .
	sbr	Temp, (1<<INT2)	
	out	GICR, Temp	

  ;    .

  ; .	;     
	in	Temp, TIMSK	;    
	sbr	Temp, (1<<OCIE2);   .
	out	TIMSK, Temp
	ldi	Temp, (1<<WGM21); 2    Auto Reload.
	out	TCCR2, Temp	


	sei			;Enable global interrupts.
